/*
  gui-js/filefox.js (c) 2008-20011 whygee@f-cpu.org
  This file is distributed under terms of the Affero GPL v3 license or later, see http://yasep.org
  created 2009-05-29 from various previous prototypes
  version 2009-05-31
  version 2009-07-07 : moved to JSgui
  version 2011-10-18 : moved to gui-js, cleanup, etc.
  version 2011-10-28 : changed into an object to be available from eval()
  version 2011-11-07 : addd ygwm hooks, timeout
  version 2012-04-23 : splitting DOM/backend, integrating load?

Based on an article published in GNU/Linux Magazine France
and written by myself. Many enhancements have been included.

For the backup of JS data to the local disk, 2 methods are implemented :
 - "save as open window" (simple but not very practical)
 - loopback with PHP (better but more complex)
Note that the loopback may be deactivated on yasep.org
but you can add one on your local machine.
It's easy under Linux, just install the Apache and PHP packages.
It's even easier on Windows with EasyPHP !

Load, save and configuration are managed by separate windows/keys.
It's not yet possible to save/load from multiple different keys.

* "settings" : the configuration window is just an interface to
 some of the internal variables (they are now decoupled from the GUI).

* "save" : a dedicated window that gets a string and saves it to a file.
gui-js/savefile.js contains 

*/




//BORK!!!!!!!!!!!!!!!!!!!!





blackList("filefox_form");

FF={
// Various DOM objects for the input/output of informations,
// beware of race conditions
  msg_id:null,
  loopback_address_id:null,
  save_with_loopback_id:null,
  callback_user:null,

// can be replaced by something more suitable depending on the interface
  message: function(col, text) {
    FF.msg_id.innerHTML = '<font color="'+col+'">'+text+"</font>";
  },

  retry_delay:30000, // don't probe again within 30s (reduce server load)
  retry_flag:null,
  retry: function(){
    FF.retry_flag=null;
    FF.message("black","");
  },

///////////////////////////////////////////////////////////////////
//  Check the loopback server
///////////////////////////////////////////////////////////////////

// address of the loopback server :
  target_loopback:null,
  semaphore:0,
  form:null,
  old_action:"",
  save_with_loopback:true,

  getSemaphore: function() {
    FF.semaphore++;
  },

  releaseSemaphore: function() {
    if (FF.semaphore<=0) {
//      console.info("semaphore over-release ????");
      alert("FF.releaseSemaphore :\nsemaphore over-release ????");
      return; // Justin Case
    }
    FF.semaphore--;
    if (FF.semaphore==0){
      if (typeof FF.callback_user=="function") {
        FF.callback_user();
        FF.callback_user=null; // cleanup
      }
    }
  },

  // Asynchronous detection :
  probe_server: function(up, down) {
    FF.message("black", "Probing the server...");
    FF.getSemaphore();
    try{
      var XHR = new XMLHttpRequest();
      XHR.open("POST",FF.target_loopback, true);
      XHR.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
      XHR.onreadystatechange=function() {
        if (XHR.readyState==4) {
          try{
            if ((XHR.status == 200) // HTTP OK 
             && (XHR.responseText == "signaturemagique")) {
              FF.message("green", "Loopback: OK");
              if (FF.retry_flag)
                clearTimeout(FF.retry_flag);
              FF.retry_flag=setTimeout(FF.retry,FF.retry_delay);
              up();
            }
            else
              down();
          }
          catch(err) {
            down();
          }
        }
      };
      XHR.send("probe=yakekin");
    }
    catch(err) {
      down();
    }
  },



///////////////////////////////////////////////////////////////////
//  Export to file / Save to disk
///////////////////////////////////////////////////////////////////

// Save the contents to a pop-up window, its contents must be cut-pasted
// by the user to the desired file.
  saveWin:null, // container of the created pop-up window

  save_to_screen: function(data) {
// Characters with accents (ASCII code > 126)
// should also be replaced, but YASEP doesn't use them (AFAIK)

    // Close the window if it is already open
    if (FF.saveWin)
      FF.saveWin.close();

    // create the new window
    FF.saveWin = window.open("", "", "menubar=yes,width=300,height=300");

    // commit the data to the new window
    FF.saveWin.document.write("<pre>"+data.replace(/</g,"&lt;").replace(/&/g,"&amp;")+"</pre>");
    FF.saveWin.document.close();
  },

  // Callback if success : send data
  server_is_up: function() {
    FF.old_action=FF.form.action; // backup
      FF.form.action=FF.target_loopback;
      FF.form.submit();
    setTimeout(function(){
      FF.form.action=FF.old_action;
      FF.message("black","OK");
      FF.releaseSemaphore();
    },200); // restore
  },

// Callback if failure
  server_is_down: function() {
    FF.callback_is_down();
    // no server ? then use the archaic method
    alert("No loopback server was found so the fallback method is used.\n"
         +"This method will be used from now on, until you select the loopback method again.\n"
         +"Please press CTRL+S to save the contents of the window that will appear.\n"
         +"*BEWARE* Save under a different file name and with the proper type  !");
    FF.save_to_screen(FF.form.filecontents.value);
  },

  callback_is_down: function() {
    FF.message("red", FF.target_loopback+" is unreachable");
    FF.callback_user=null; // cleanup
    FF.disable_loopback();
    FF.releaseSemaphore();
  },

  // This is the entry point for "save" the form :
  save_to_disk: function(){
    if (FF.save_with_loopback==true) {
      if (FF.semaphore!=0)
        FF.message("orange", "File operation in progress, please try again later.");
      else {
        if (!FF.retry_flag) // Last probe was long ago, recheck
          FF.probe_server(FF.server_is_up, FF.server_is_down);
        else {
          FF.getSemaphore();
          FF.server_is_up();
        }
      }
    }
    else
      FF.save_to_screen(FF.form.filecontents.value);
  },

/*
  // These functions generate HTML code for the forms
  // (unused ?)
  make_form: function(filename, columns, lines) {
    if (!lines) lines="7";
    if (!columns) columns="50";
    var m='<p><form method="post" name="filefox_form" id="filefox_form" target="filefox_target" >';
    if (filename)
      m+='<input type="hidden" name="filename" id="filename" value="'+filename+'">';
    else
      m+='Name of the file that will be saved : <input type="text" size="30"'
       +' name="filename" id="filename" value="filename">';
    m+='<br><textarea style="display:block" rows="'+lines+'" cols="'+columns+'" scrollbar="auto"'
     +' name="filecontents" id="filecontents"></textarea></form>\n'
     +'<input type="submit" value="Save';
     if (filename)
       m+=" as "+filename;
   m+='" id="clicksave"> &nbsp;'
     +'<input type="submit" value="Show/hide data" onclick="a=document.filefox_form'
     +'.filecontents.style; if (a.display==\'none\') a.display=\'block\'; else a.display=\'none\';"></p>';
    return m;
  },

  make_ctl: function() {
    var m='<p>Use PHP loopback'
    +'<input id="check_save_method" type="checkbox"><br>'
    +'Loopback address : <input type="text" size="40" name="loopback_address" id="loopback_address">'
    +'<input id="submit_server" type="submit" value="change">'
    +'<div id="status_div"></div>'
    +'<iframe name="filefox_target" id="filefox_target" style="display:none"></iframe></p>';
    return m;
  },
*/

///////////////////////////////////////////////////////////////////
//  Import from file or another web site
///////////////////////////////////////////////////////////////////

/*
// TODO !

  LoadFile:function(src){
    var xhr;
    try{
      xhr=new XMLHttpRequest();
      xhr.open("GET", src, false);
      xhr.send(null);
      return xhr.responseText;
    }
    catch(err) {
      return alert(src+" can't be loaded");
    }
  },
*/

///////////////////////////////////////////////////////////////////
// cookie settings / configuration / management
///////////////////////////////////////////////////////////////////

  disable_loopback: function() {
    FF.save_with_loopback = false;
    FF.save_with_loopback_id.checked=false;
    // update_cookie
    if (cookies) {
      FF.target_loopback=null;      
      cookies.save();
    }
  },

  probe_failure: function() {
    FF.callback_user=null; // cleanup
    FF.message("red",FF.target_loopback+" is unreachable");
    FF.disable_loopback();
    FF.releaseSemaphore();
  },

  enable_loopback: function() {
    FF.save_with_loopback = true;
    FF.save_with_loopback_id.checked=true;
    // update_cookie
    if (cookies)
      cookies.save();
  },

  probe_success: function() {
    FF.enable_loopback();
    FF.releaseSemaphore();
  },

  set_save_with_loopback: function(val) {
    if (val/*==true*/)
      // test the loopback server
      FF.probe_server(FF.probe_success, FF.probe_failure);
    else
      FF.disable_loopback();
  },

  update_loopback_address: function(adr) {
    FF.target_loopback=adr;
    FF.loopback_address_id.value=adr;

    // PHP loopback only works with HTTP
    if (FF.target_loopback.indexOf("http://")==0)
      FF.set_save_with_loopback(true);
    else {
      FF.disable_loopback();
      FF.message("orange","notice : Loopback can only work with http:// addresses");
    }
  },

  // To be called _after_ the interface is mapped/displayed

  init_loopback: function(base_id) {
    function get(i){
      return getById(i,null,base_id)
    };

    (FF.save_with_loopback_id=get("check_save_method")).onclick
   =function(){
      FF.set_save_with_loopback(FF.save_with_loopback_id.checked);
    };
    FF.msg_id = base_id.messsage_id; // might be changed later to another window...

// ****************

    FF.loopback_address_id=get("loopback_address");
    get("submit_server").onclick=(
      FF.loopback_address_id.onchange=
        function(){FF.update_loopback_address(FF.loopback_address_id.value);});

    // check if the field has been preserved by the browser through a page reload
    if(FF.loopback_address_id.value=="") {
      // if no previous address, provide a default loopback
      var p=document.location+""; // Make a string
      p=p.replace(/[#].*/,"");  // remove trailing garbage (keys ?)
      FF.update_loopback_address(p.substring(0, p.lastIndexOf("/"))+"/gui-js/loopback.php");
    }
    else
      FF.update_loopback_address(FF.loopback_address_id.value);
  },

  init: function(base_id) {
    if (!settings.win) {
      wa("settings");  // initialises the loopback
      settings.win.hide_all();
    }

    FF.msg_id = base_id.messsage_id;
    FF.form=document.filefox_form;
    FF.form.action=FF.save_to_disk;
    getById("clicksave",null,base_id).onclick=FF.save_to_disk;
  }
}
