/* yasep/lang.js
This file is distributed under terms of the Affero GPL v3 license or later, see http://yasep.org
created 20110909 by whygee@f-cpu.org
20110912 : objectified
20111122 : body_start() can change the default language
20120513 : moved the pictures as divs in logos/logos.css

Some definitions and general utilities for managing the languages.
LANG is also read/written by yasep/cookies.js
*/

init_obj.push(LANG={
  LANGS:["en", "fr"], // "es"],
  LANGUAGES:["English", "Français"], // "Español"],
  LANG:0, // changed when reading the cookies or by body_start.js
  // LANG could become any large integer number, as it gets encoded/decoded in base66.

// inline images to save some HTTP requests
  FLAGS:[],

  EditListing:[
    "Edit this listing",
    "Éditer ce listing"
  ],

  change_innerHTML: [], // beware of memory leaks !
  change_title: [],

  change_lang: function(i){
    var j,k;
    if ((i<0)||(i>=LANG.LANGS.length))
      i=0;

    LANG.LANG=i;
    l=LANG.LANGS[i];
    cookies.save();

    for (j in LANG.change_innerHTML){
      k=LANG.change_innerHTML[j];
      if(typeof k[1][i] == "string")
        k[0].innerHTML=k[1][i];
      else
        if(typeof k[1][0] == "string")
          k[0].innerHTML=k[1][0];
    }
  },

  // To be called AFTER menu.create() AND init_cookies() !
  init_obj: function() {
    // Create the language picker menu
    var i,l=menu.list["LNG"];

    for (i in LANG.LANGS)
      menu.subMenuItem(l,
        [ LANG.FLAGS[i]='<div class="flag_'+LANG.LANGS[i]+'"></div>' ], // Initialises the array
        function(i){
          return function(){
            LANG.change_lang(i) // looks weird but it
          } // just a function then calls it for getting a function with closure...
        }(i) 
      ).title=LANG.LANGUAGES[i]; // got it ? :-P

    LANG.change_innerHTML.push([l.firstChild, LANG.FLAGS]);
    l.title="Switch language";
    // set to the current language logo 
    LANG.change_lang(LANG.LANG);
  }
});
